<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>GTRACK Algorithm</title>
<link href="doxygen.css" rel="stylesheet" type="text/css">
<link href="tabs.css" rel="stylesheet" type="text/css">
</head><body>
<table width=100%>
<tr>
  <td bgcolor="black" width="1"><a href="http://www.ti.com"><img border=0 src="../../tilogo.gif"></a></td>
  <td bgcolor="red"><img src="../../titagline.gif"></td>
</tr>
</table>
<!-- Generated by Doxygen 1.8.11 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li class="current"><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Data&#160;Structures</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">GTRACK Algorithm </div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><p>This code is an implementation of Group TRACKing algorithm.<br />
 The algorithm is designed to track multiple targets, where each target is represented by a set of measurement points.<br />
 Each measurement point carries detection informations, for example, range, angle, and radial velocity.<br />
 Instead of tracking individual reflections, the algorithm predicts and updates the location and dispersion properties of the group.<br />
 The group is defined as the set of measurements (typically, few tens; sometimes few hundreds) associated with a real life target.<br />
</p>
<h3>Input/output</h3>
<ul>
<li>Algorithm inputs the Point Cloud. For example, few hundreds of individual measurements (reflection points).<br />
</li>
<li>Algorithm outputs a Target List. For example, an array of few tens of target descriptors. Each descriptor carries a set of properties for a given target.<br />
</li>
<li>Algorithm optionally outputs a Target Index. If requested, this is an array of target IDs associated with each measurement.<br />
</li>
</ul>
<h3>Features</h3>
<ul>
<li>Algorithm uses extended Kalman Filter to model target motion in Cartesian coordinates.<br />
</li>
<li>Algorithm supports constant velocity and constant acceleartion models.<br />
</li>
<li>Algorithm uses 3D Mahalanobis distances as gating function and Max-likelihood criterias as scoring function to associate points with an existing track.<br />
</li>
</ul>
<h2>External API</h2>
<p>Application includes the following algorithm header </p><div class="fragment"><div class="line"><span class="preprocessor">#include &lt;ti/alg/gtrack.h&gt;</span></div></div><!-- fragment --><p> All resources are allocated at create time during the <a class="el" href="group___g_t_r_a_c_k___a_l_g___e_x_t_e_r_n_a_l___d_a_t_a___s_t_r_u_c_t_u_r_e.html#ga2733d052b2cd02bb8211eb817aa3190d">gtrack_create</a> call. <br />
 All resources are freed at delete time time during the <a class="el" href="group___g_t_r_a_c_k___a_l_g___e_x_t_e_r_n_a_l___d_a_t_a___s_t_r_u_c_t_u_r_e.html#ga0ab64b40df30e6956990bb79d63e78b4">gtrack_delete</a> call. <br />
 Application is expected to implement the design pattern as described in the pseudo code bellow: </p><div class="fragment"><div class="line">h = <a class="code" href="group___g_t_r_a_c_k___a_l_g___e_x_t_e_r_n_a_l___f_u_n_c_t_i_o_n.html#ga2733d052b2cd02bb8211eb817aa3190d">gtrack_create</a>(params);                      <span class="comment">// Creates an instance of the algorithm with a desired configuration</span></div><div class="line"><span class="keywordflow">while</span>(running) {</div><div class="line">    <a class="code" href="group___g_t_r_a_c_k___a_l_g___e_x_t_e_r_n_a_l___f_u_n_c_t_i_o_n.html#gab690635a7210e712a6d3ab4eef331071">gtrack_step</a>(h, pointCloud, &amp;targetList);    <span class="comment">// Runs a single step of the given alrorithm instance with input point cloud data</span></div><div class="line">}</div><div class="line"><a class="code" href="group___g_t_r_a_c_k___a_l_g___e_x_t_e_r_n_a_l___f_u_n_c_t_i_o_n.html#ga0ab64b40df30e6956990bb79d63e78b4">gtrack_delete</a>(h);                               <span class="comment">// Delete the algorithm instance</span></div></div><!-- fragment --> <h3>Dependencies</h3>
<p>Library is platform independent. To port the library, platform shall implement few functions that Library abstracts, see <a class="el" href="group___g_t_r_a_c_k___dependencies.html">Dependencies</a></p>
<h2>Internal Architecture of the GTRACK Algorithm</h2>
<p>Algorithm is implemented with two internal software sublayers: Module and Units(s). <br />
 Application can create multiple Module instances with different configuration parameters (for example, to track different classes of targets).<br />
 Each Module instance creates amd manages multiple units.<br />
 Each Unit represents a single tracking object.<br />
 Units inherit configuration parameters from the parent Module.<br />
 </p><h3>Module level</h3>
<p>The imlementation of <a class="el" href="group___g_t_r_a_c_k___a_l_g___e_x_t_e_r_n_a_l___d_a_t_a___s_t_r_u_c_t_u_r_e.html#ga2733d052b2cd02bb8211eb817aa3190d">gtrack_create</a> function creates a module instance and pre-allocates resources for a maximum number of units.<br />
 The imlementation of <a class="el" href="group___g_t_r_a_c_k___a_l_g___e_x_t_e_r_n_a_l___d_a_t_a___s_t_r_u_c_t_u_r_e.html#gab690635a7210e712a6d3ab4eef331071">gtrack_step</a> function calls one single round of module functions as illustrated in the pseudo code below: </p><div class="fragment"><div class="line"><a class="code" href="group___g_t_r_a_c_k___a_l_g___e_x_t_e_r_n_a_l___f_u_n_c_t_i_o_n.html#gab690635a7210e712a6d3ab4eef331071">gtrack_step</a>(h, pointCloud, &amp;targetList) {</div><div class="line">    <a class="code" href="group___g_t_r_a_c_k___a_l_g___m_o_d_u_l_e___f_u_n_c_t_i_o_n.html#gae6cd873b8ef7433bb347d61af3f167f3">gtrack_modulePredict</a>(h,...);</div><div class="line">    <a class="code" href="group___g_t_r_a_c_k___a_l_g___m_o_d_u_l_e___f_u_n_c_t_i_o_n.html#ga89de00903da0d194c6f561dc501dabfe">gtrack_moduleAssociate</a>(h,...);</div><div class="line">    <a class="code" href="group___g_t_r_a_c_k___a_l_g___m_o_d_u_l_e___f_u_n_c_t_i_o_n.html#ga3c16a30d0d0e4a211417d2e155e87993">gtrack_moduleAllocate</a>(h,...);</div><div class="line">    <a class="code" href="group___g_t_r_a_c_k___a_l_g___m_o_d_u_l_e___f_u_n_c_t_i_o_n.html#ga898cc5c80f24fb5a9d3fa4932e519442">gtrack_moduleUpdate</a>(h,...);</div><div class="line">    <a class="code" href="group___g_t_r_a_c_k___a_l_g___m_o_d_u_l_e___f_u_n_c_t_i_o_n.html#gae9c4d673ab363f0e8d8c26df946a7b3f">gtrack_moduleReport</a>(h,...);</div><div class="line">}</div></div><!-- fragment --><p> The imlementation of <a class="el" href="group___g_t_r_a_c_k___a_l_g___e_x_t_e_r_n_a_l___d_a_t_a___s_t_r_u_c_t_u_r_e.html#ga0ab64b40df30e6956990bb79d63e78b4">gtrack_delete</a> function returns all the resources back to the system </p><h3>Unit level</h3>
<p>Units are created during <a class="el" href="group___g_t_r_a_c_k___a_l_g___m_o_d_u_l_e___f_u_n_c_t_i_o_n.html#ga3c16a30d0d0e4a211417d2e155e87993">gtrack_moduleAllocate</a> calls.<br />
 The resources pre-allocated at module create time are assigned to a new unit.<br />
 All active units are called during each parent module function step calls.<br />
 As an example, the pseudo code below illustrates the implementation of the predict function: </p><div class="fragment"><div class="line"><a class="code" href="group___g_t_r_a_c_k___a_l_g___m_o_d_u_l_e___f_u_n_c_t_i_o_n.html#gae6cd873b8ef7433bb347d61af3f167f3">gtrack_modulePredict</a>(h,...) {</div><div class="line">    <span class="keywordflow">for</span>(each active unit) {</div><div class="line">        gtrack_unit_predict(unit, ...);</div><div class="line">    }</div><div class="line">}</div></div><!-- fragment --><p> Units are deleted during <a class="el" href="group___g_t_r_a_c_k___a_l_g___m_o_d_u_l_e___f_u_n_c_t_i_o_n.html#ga898cc5c80f24fb5a9d3fa4932e519442">gtrack_moduleUpdate</a> calls. The resources are returned back to the parent module. </p>
</div></div><!-- contents -->
<hr size="1"><small>
Copyright  2018, Texas Instruments Incorporated</small>
</body>
</html>
